from sensor.Sensor import Sensor
from utils.datatypes import *
from utils import i18n
import time
import os

class Theme(Sensor):

	def __init__(self, group, part):
		
		global _; _ = i18n.Translator("theme-sensor")
		Sensor.__init__(self)
		home = os.getenv("HOME")
		if os.path.exists(home + "/.gdesklets/Themes/" + group):
			self.__Sensor_Root = home + "/.gdesklets/Themes/"
		else :
			self.__Sensor_Root = "/usr/X11R6/share/gnome/gdesklets/Themes/"
		
		self.__Group = group
		self.__Part = part
		
		try :
			fd = open(self.__Sensor_Root + self.__Group +"/"+ self.__Part +"/themes", "r")
			output = fd.read()
			fd.close()
		except :
			output = ""
		
		output = output.splitlines()
		self.__Themes = []
		for a in output[0].split():
			self.__Themes.append([a,a])
			
		self.__Elements = output[1].split()
		
		self._set_config_type("show", TYPE_BOOL, 1)
		self._set_config_type("theme", TYPE_STRING, self.__Themes[0][0])
		self._set_config_type("alt", TYPE_INT, 0)
		
		self._watch_config(self.config_watcher)
		
		self._add_timer(500, self.__theme_init)

	def config_watcher(self,key,value):
		if key == "show":
			data = self._new_output()
			data.set(key, value)
			self._send_output(data)
		elif key == "theme":
			data = self._new_output()
			dir = self.__Sensor_Root + self.__Group +"/"+ self.__Part +"/"+ value +"/"
			alt = self._get_config("alt")
			
			if (alt == 0):
				alts = ""
			else :
				alts = "-%i" % alt
			
			for element in self.__Elements:
				data.set(element, dir + element + alts + ".png" )
			self._send_output(data)
		elif key == "alt":
			data = self._new_output()
			dir = self.__Sensor_Root + self.__Group +"/"+ self.__Part +"/"+ self._get_config("theme") +"/"
			alt = int(value)
			print value
			if (alt == 0):
				alts = ""
			else :
				alts = "-%i" % alt
			
			for element in self.__Elements:
				data.set(element, dir + element + alts + ".png" )
				
			self._send_output(data)

	def __theme_init(self):
		data = self._new_output()
		
		show = self._get_config("show")
		theme = self._get_config("theme")
		alt = self._get_config("alt")
		
		data.set("show", show)
		
		if (alt == 0):
			alts = ""
		else :
			alts = "-%i" % alt
		
		dir = self.__Sensor_Root + self.__Group +"/"+ self.__Part +"/"+ theme +"/"
		for element in self.__Elements:
			data.set(element, dir + element + alts + ".png" )
		
		self._send_output(data)
		
		return 0

	def get_configurator(self):
		configurator = self._new_configurator()
		configurator.set_name(_(self.__Part))
		configurator.add_title(_(self.__Group))
		configurator.add_checkbox(_("Show this part"), "show",
					_("Shows or hides this part of the display"))
		print self.__Themes
		configurator.add_option(_("Theme"), "theme",
					_("Possible themes"),self.__Themes)
		configurator.add_spin(_("Alternative"), "alt",
					_("Possible themes alternative (same theme, same part but alternative in the theme (useful for icons))"),0,1000)
		return configurator

def new_sensor(args): return apply(Theme, args)
